% Options for packages loaded elsewhere
\PassOptionsToPackage{unicode}{hyperref}
\PassOptionsToPackage{hyphens}{url}
\PassOptionsToPackage{dvipsnames,svgnames,x11names}{xcolor}
%
\documentclass[
  letterpaper,
  DIV=11,
  numbers=noendperiod]{scrartcl}

\usepackage{amsmath,amssymb}
\usepackage{iftex}
\ifPDFTeX
  \usepackage[T1]{fontenc}
  \usepackage[utf8]{inputenc}
  \usepackage{textcomp} % provide euro and other symbols
\else % if luatex or xetex
  \usepackage{unicode-math}
  \defaultfontfeatures{Scale=MatchLowercase}
  \defaultfontfeatures[\rmfamily]{Ligatures=TeX,Scale=1}
\fi
\usepackage[]{libertinus}
\ifPDFTeX\else  
    % xetex/luatex font selection
\fi
% Use upquote if available, for straight quotes in verbatim environments
\IfFileExists{upquote.sty}{\usepackage{upquote}}{}
\IfFileExists{microtype.sty}{% use microtype if available
  \usepackage[]{microtype}
  \UseMicrotypeSet[protrusion]{basicmath} % disable protrusion for tt fonts
}{}
\makeatletter
\@ifundefined{KOMAClassName}{% if non-KOMA class
  \IfFileExists{parskip.sty}{%
    \usepackage{parskip}
  }{% else
    \setlength{\parindent}{0pt}
    \setlength{\parskip}{6pt plus 2pt minus 1pt}}
}{% if KOMA class
  \KOMAoptions{parskip=half}}
\makeatother
\usepackage{xcolor}
\usepackage[top=30mm,left=20mm,heightrounded]{geometry}
\setlength{\emergencystretch}{3em} % prevent overfull lines
\setcounter{secnumdepth}{-\maxdimen} % remove section numbering
% Make \paragraph and \subparagraph free-standing
\ifx\paragraph\undefined\else
  \let\oldparagraph\paragraph
  \renewcommand{\paragraph}[1]{\oldparagraph{#1}\mbox{}}
\fi
\ifx\subparagraph\undefined\else
  \let\oldsubparagraph\subparagraph
  \renewcommand{\subparagraph}[1]{\oldsubparagraph{#1}\mbox{}}
\fi


\providecommand{\tightlist}{%
  \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}\usepackage{longtable,booktabs,array}
\usepackage{calc} % for calculating minipage widths
% Correct order of tables after \paragraph or \subparagraph
\usepackage{etoolbox}
\makeatletter
\patchcmd\longtable{\par}{\if@noskipsec\mbox{}\fi\par}{}{}
\makeatother
% Allow footnotes in longtable head/foot
\IfFileExists{footnotehyper.sty}{\usepackage{footnotehyper}}{\usepackage{footnote}}
\makesavenoteenv{longtable}
\usepackage{graphicx}
\makeatletter
\def\maxwidth{\ifdim\Gin@nat@width>\linewidth\linewidth\else\Gin@nat@width\fi}
\def\maxheight{\ifdim\Gin@nat@height>\textheight\textheight\else\Gin@nat@height\fi}
\makeatother
% Scale images if necessary, so that they will not overflow the page
% margins by default, and it is still possible to overwrite the defaults
% using explicit options in \includegraphics[width, height, ...]{}
\setkeys{Gin}{width=\maxwidth,height=\maxheight,keepaspectratio}
% Set default figure placement to htbp
\makeatletter
\def\fps@figure{htbp}
\makeatother

\KOMAoption{captions}{tableheading}
\makeatletter
\makeatother
\makeatletter
\makeatother
\makeatletter
\@ifpackageloaded{caption}{}{\usepackage{caption}}
\AtBeginDocument{%
\ifdefined\contentsname
  \renewcommand*\contentsname{Table of contents}
\else
  \newcommand\contentsname{Table of contents}
\fi
\ifdefined\listfigurename
  \renewcommand*\listfigurename{List of Figures}
\else
  \newcommand\listfigurename{List of Figures}
\fi
\ifdefined\listtablename
  \renewcommand*\listtablename{List of Tables}
\else
  \newcommand\listtablename{List of Tables}
\fi
\ifdefined\figurename
  \renewcommand*\figurename{Figure}
\else
  \newcommand\figurename{Figure}
\fi
\ifdefined\tablename
  \renewcommand*\tablename{Table}
\else
  \newcommand\tablename{Table}
\fi
}
\@ifpackageloaded{float}{}{\usepackage{float}}
\floatstyle{ruled}
\@ifundefined{c@chapter}{\newfloat{codelisting}{h}{lop}}{\newfloat{codelisting}{h}{lop}[chapter]}
\floatname{codelisting}{Listing}
\newcommand*\listoflistings{\listof{codelisting}{List of Listings}}
\usepackage{amsthm}
\theoremstyle{definition}
\newtheorem{exercise}{Exercise}[section]
\theoremstyle{remark}
\AtBeginDocument{\renewcommand*{\proofname}{Proof}}
\newtheorem*{remark}{Remark}
\newtheorem*{solution}{Solution}
\makeatother
\makeatletter
\@ifpackageloaded{caption}{}{\usepackage{caption}}
\@ifpackageloaded{subcaption}{}{\usepackage{subcaption}}
\makeatother
\makeatletter
\@ifpackageloaded{tcolorbox}{}{\usepackage[skins,breakable]{tcolorbox}}
\makeatother
\makeatletter
\@ifundefined{shadecolor}{\definecolor{shadecolor}{rgb}{.97, .97, .97}}
\makeatother
\makeatletter
\makeatother
\makeatletter
\makeatother
\ifLuaTeX
  \usepackage{selnolig}  % disable illegal ligatures
\fi
\IfFileExists{bookmark.sty}{\usepackage{bookmark}}{\usepackage{hyperref}}
\IfFileExists{xurl.sty}{\usepackage{xurl}}{} % add URL line breaks if available
\urlstyle{same} % disable monospaced font for URLs
\hypersetup{
  pdftitle={IA168 AGT -- Homework \#2},
  pdfauthor={Štěpán Zapadlo (505579)},
  colorlinks=true,
  linkcolor={blue},
  filecolor={Maroon},
  citecolor={Blue},
  urlcolor={Blue},
  pdfcreator={LaTeX via pandoc}}

\title{IA168 AGT -- Homework \#2}
\author{Štěpán Zapadlo (505579)}
\date{2023-12-05}

\begin{document}
\maketitle
% Declare mathematics (so they can be overwritten for PDF)
\gdef \declareMathematics#1#2{\gdef #1{\mathrm{#2}}}
\gdef \declareMathematicsStar#1#2{\gdef #1{\mathop{\mathrm{#2}}}}

% Font styles
\gdef \mcal#1{\mathcal{#1}}

% Sets
\gdef \C{\mathbb{C}}
\gdef \R{\mathbb{R}}
\gdef \Z{\mathbb{Z}}
\gdef \N{\mathbb{N}}

% Basic notation - vectors and random variables 
\gdef \vi#1{\boldsymbol{#1}} %standard vector
\gdef \dvi#1{\vi{\dot{#1}}} %differentiated vector
\gdef \vii#1{\mathbf{#1}} %still a vector if vi doesn't work
\gdef \dvii#1{\vii{\dot{#1}}} %differ. vector
\gdef \vr#1{\mathbf{#1}} %matrix
\gdef \dvr#1{\vr{\dot{#1}}} %differ. matrix
\gdef \vb#1{\pmb{#1}} %#TODO
\gdef \dvb#1{\vb{\dot{#1}}} %#TODO

% Basic notation - general
\gdef \set#1{\left\{#1\right\}}
\gdef \brackets#1{\left( #1 \right)}
\gdef \dom#1{\mcal{D}\, \brackets{#1}}

% Special symbols
\gdef \vf{\varphi}
\gdef \ve{\varepsilon}
\gdef \xx{\vi x}
\gdef \tht{\theta}

% Basic functions
\gdef \absval#1{\left| #1 \right|}
\gdef \id{\mathrm{id}}
\gdef \floor#1{\left\lfloor #1 \right\rfloor}
\declareMathematics{\im}{im} %image
\declareMathematics{\tg}{tg}
\declareMathematics{\sign}{sign}
\declareMathematics{\card}{card} %cardinality
\declareMathematics{\exp}{exp}
\gdef \indicator#1{\mathbb{I}_{#1}}

% Operators - Analysis
\gdef \hess{\nabla}
\gdef \lagr{\mcal L}
\declareMathematics{\grad}{grad}
\gdef \d{\mathrm{d}}
\gdef \partialDeriv#1#2{\frac {\partial #1} {\partial #2}}
\gdef \partialOp#1{\frac {\partial} {\partial #1}}
\gdef \deriv#1#2{\frac {\d #1} {\d #2}}
\gdef \derivOp#1{\frac {\d} {\d #1}\,}

% Linear algebra
\gdef \norm#1{\left\lVert #1 \right\rVert}
\gdef \scal#1#2{\left\langle #1, #2 \right\rangle}
\gdef \avg#1{\overline{#1}}

% Linear algebra - Matrices
\gdef \tr{\top}
\gdef \Tr{^\tr}
\gdef \pinv{\dagger}
\gdef \Pinv{^\dagger}
\gdef \ident{\mathbb{I}}
\gdef \mtr#1{\begin{pmatrix}#1\end{pmatrix}}
\gdef \bmtr#1{\begin{bmatrix}#1\end{bmatrix}}

% Statistics
\gdef \noise{\mcal{N}}
\gdef \iid{\overset{\text{iid}}{\sim}}
\gdef \ind{\overset{\text{ind}}{\sim}}
\gdef \acov{\gamma}
\gdef \acf{\rho}
\gdef \stdev{\sigma}
\declareMathematics{\variance}{var}
\gdef \Variance#1{\variance \brackets{#1}}
\declareMathematics{\cov}{cov}
\declareMathematics{\corr}{cor}
\declareMathematics{\expectedValue}{E}
\gdef \expect#1{\expectedValue #1}
\gdef \Expect#1{\expectedValue \brackets{#1}}
\gdef \WN#1#2{\mathrm{WN}\brackets{#1,#2}}
\declareMathematics{\uniform}{Unif}
\gdef \pdist{\sigma}


% Game Theory
\gdef \doms{\succ}
\gdef \isdom{\prec}
\gdef \OfOthers#1{_{-#1}}
\gdef \ofOthers{\OfOthers{i}}
\gdef \domGame#1{G_{DS}^{#1}}
\gdef \ratGame#1{G_{Rat}^{#1}}
\gdef \bestRep#1#2{\mathrm{BR}_{#1}\brackets{#2}}
\gdef \perf#1{{#1}_{\mathrm{perf}}}
\gdef \imperf#1{{#1}_{\mathrm{imp}}}


% Optimization
\declareMathematicsStar{\argmin}{argmin}
\declareMathematicsStar{\argmax}{argmax}
\declareMathematics{\prox}{prox}
\declareMathematics{\loss}{loss}
\declareMathematics{\supp}{supp}
\gdef \Koop{\mcal K}
\gdef \oneToN#1{\left[#1\right]}
\gdef \constraint{\text{s.t.}\;}

% Useful commands
\gdef \onTop#1#2{\mathrel{\overset{#2}{#1}}}
\gdef \onBottom#1#2{\mathrel{\underset{#2}{#1}}}
\gdef \tOnTop#1#2{\mathrel{\overset{\text{#2}}{#1}}}
\gdef \EQ{\onTop{=}{!}}
\gdef \isPDef{\onTop{\succ}{?}}

\setcounter{section}{1}
\renewcommand{\theexercise}{\arabic{exercise}}

\ifdefined\Shaded\renewenvironment{Shaded}{\begin{tcolorbox}[interior hidden, borderline west={3pt}{0pt}{shadecolor}, boxrule=0pt, breakable, frame hidden, enhanced, sharp corners]}{\end{tcolorbox}}\fi

In \textbf{all} of the exercises, \textbf{finite-horizon} extensive-form
game will be assumed, as necessary concepts for infinite-horizon
extensive-form game were not covered in the lectures.

\begin{exercise}[]\protect\hypertarget{exr-first}{}\label{exr-first}

Give a formal description of rock-paper-scissors as a two-player
\textbf{imperfect}-information extensive-form game (i.e., according to
the definition from the lectures).

\end{exercise}

\begin{solution}

Quite easily, one can represent rock-paper-scissors as a graph
prescribing a two-player imperfect-information extensive-form game
\({G}_{\mathrm{imp}}\) shown in Figure~\ref{fig-rps-imp}.

\begin{figure}[h]

{\centering \includegraphics{hw2_files/mediabag/problem_1_sol.drawio.pdf}

}

\caption{\label{fig-rps-imp}Graph of rock-paper-scissors as a two-player
imperfect-information game \({G}_{\mathrm{imp}}\)}

\end{figure}

Now recall from the lectures that an imperfect-information game
\({G}_{\mathrm{imp}}\) is defined as a tuple
\({G}_{\mathrm{imp}} = \left( {G}_{\mathrm{perf}}, I \right)\), where
\({G}_{\mathrm{perf}}\) is the underlying perfect-information game and
\(I\) is \(|N|\)-tuple of information sets for each player. As the
perfect-information corresponding game \({G}_{\mathrm{perf}}\) is a
tuple
\({G}_{\mathrm{perf}} = \left( N, A, H, Z, \chi, \rho, \pi, h_0, \boldsymbol{u} \right)\),
we can prescribe it as

\begin{itemize}
\tightlist
\item
  \(N = \left\{1,2\right\}\) is the set of players;
\item
  \(A = \left\{\mathrm{R}, \mathrm{P}, \mathrm{S}\right\}\) is the set
  of all possible actions;
\item
  \(H = \left\{h_0, h_1, h_2, h_3\right\}\) is the set of all
  \emph{non-terminal} nodes;
\item
  \(Z = \left\{h_4, h_5, \dots, h_{12}\right\}\) is the set of all
  \emph{terminal} nodes;
\item
  \(\chi : H \to (2^A \setminus \left\{\emptyset\right\})\) is the
  action function, which assigns to each non-terminal node a set of
  enabled actions, thus
  \(\chi(h_0) = \chi(h_1) = \chi(h_2) = \chi(h_3) = A = \left\{\mathrm{R}, \mathrm{P}, \mathrm{S}\right\}\);
\item
  \(\rho: H \to N\) is the player function, which assigns to each
  non-terminal node \(h\) a player \(i \in N\) who chooses from the
  enabled actions \(\chi(h)\), thus \(\rho(h_0) = 1\) and
  \(\rho(h_1) = \rho(h_2) = \rho(h_3) = 2\);
\item
  \(\pi: H \times A \to \mathcal{H} \setminus \left\{h_0\right\}\) is
  the successor function, which maps a non-terminal node \(h\) and a
  choice of enabled action \(a \in \chi(h)\) a new node
  \(h' \in \mathcal{H} \setminus \left\{h_0\right\} = H \cup Z \setminus \left\{h_0\right\}\),
  thus \[
    \pi(h_0, a) = \begin{cases}
        h_1, & a = \mathrm{R}, \\
        h_2, & a = \mathrm{P}, \\
        h_3, & a = \mathrm{S} 
    \end{cases}
    \quad \& \quad
    \pi(h_i, a) = \begin{cases}
        h_{1+3i}, & a = \mathrm{R}, \\
        h_{2+3i}, & a = \mathrm{P}, \\
        h_{3+3i}, & a = \mathrm{S}
    \end{cases}
    \] for \(i \in \left\{1,2,3\right\}\);
\item
  \(h_0\) is the root of the extensive-form game and it is the only
  node, which is not a successor of any other node;
\item
  \(\boldsymbol{u} = (u_1, u_2)\), where \(u_i : Z \to \mathbb{R}\) for
  every \(i \in N\), is the payoff function, which maps a terminal node
  to payoffs for both players, thus \[
    \boldsymbol{u}(h_i) = \begin{cases}
        (\hphantom{-}0,\hphantom{-}0), & i \in \left\{4, 8, 12\right\}, \\
        (-1,\hphantom{-}1), & i \in \left\{5, 9, 10\right\}, \\
        (\hphantom{-}1,-1), & i \in \left\{6, 7, 11\right\}
    \end{cases}
    \] for \(i \in \left\{4, \dots, 12\right\}\).
\end{itemize}

This way, we have correctly defined the underlying perfect-information
game \({G}_{\mathrm{perf}}\). Combined with \[
I = \left( \left\{\left\{h_0\right\}\right\}, \left\{\left\{h_1, h_2, h_3\right\}\right\} \right),
\] this gives us rock-paper-scissors as the imperfect-information game
\({G}_{\mathrm{imp}} = ({G}_{\mathrm{perf}}, I)\).

\end{solution}

\begin{exercise}[]\protect\hypertarget{exr-second}{}\label{exr-second}

Bob has been hired by Mafia to steal some valuable top-secret documents.
Now that Bob has done so, he has two options: Either he
\textbf{d}elivers the documents to Mafia, or he \textbf{f}lees to Europe
and sells them for twice as much. If Bob flees, Mafia either decide to
\textbf{l}eave this business and concentrate on other deals, or they
start \textbf{s}earching for Bob. In the latter case, with probability
\(p\), they eventually find Bob and kill him.

We model this scenario as the two-player perfect-information
extensive-form game depicted in Figure~\ref{fig-exr2-game}.

\begin{figure}[h]

{\centering \includegraphics{hw2_files/mediabag/problem_2_instr.drawio.pdf}

}

\caption{\label{fig-exr2-game}Bob-Mafia game}

\end{figure}

In dependence on parameter \(p\), \(0 \leq p \leq 1\), enumerate all:

\begin{enumerate}
\def\labelenumi{\alph{enumi}.}
\tightlist
\item
  never-best-response strategies;
\item
  max-min strategies;
\item
  Nash equilibria;
\item
  subgame-perfect equilibria.
\end{enumerate}

\end{exercise}

\begin{solution}

Bob-Mafia game, the game from the instructions, see
Figure~\ref{fig-exr2-game}, is an extensive-form game and as such can be
re-written as a corresponding normal (or strategic) form game

\begin{longtable}[]{@{}lll@{}}
\toprule\noalign{}
↓Bob/Mafia→ & \(l\) & \(s\) \\
\midrule\noalign{}
\endhead
\bottomrule\noalign{}
\endlastfoot
\(d\) & \((10,10)\) & \((10, 10)\) \\
\(f\) & \((20, -5)\) & \((20 - 120p,15p - 10)\) \\
\end{longtable}

First and foremost, we shall concern ourselves with never-best-response
strategies. For Bob, \(f\) is clearly a best-response to a belief \(l\)
for any value of parameter \(p\). For a probability
\(p < \frac 1 {12}\), that is \(p \in \left[0, \frac 1 {12}\right)\),
\(f\) is also a best-response to a belief \(s\) (for
\(p = \frac 1 {12}\) both \(d\) and \(f\) are best-responses to \(s\),
while for \(p > \frac 1 {12}\) only \(d\) is a best-response to \(s\)).
Thus for \(p \in \left[0, \frac 1 {12}\right)\), \(d\) is a
never-best-response. For Mafia, for any value of the parameter \(p\),
both \(l\) and \(s\) are best-responses to the belief \(d\), hence there
is no never-best-response for Mafia.

Continuing to max-min strategies, we can realize we were tasked with
finding \textbf{only pure} strategies, thus we can omit mixed strategies
from our analysis (although it can be shown that in this case, max-min
strategies only realize as pure). Again we shall first focus on Bob, for
which any max-min strategy \(s^M_{\text{Bob}}\) satisfies (see the
\href{https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf\#page=348}{definition
of max-min strategy}) \[
s^M_{\text{Bob}} \in \mathop{\mathrm{argmax}}_{s \in \left\{d, f\right\}} \min_{s' \in \left\{l, s\right\}} u_1(s, s').
\]

Recall that for \(p = \frac 1 {12}\) the payoff \(\boldsymbol{u}(f,s)\)
has the value \(\boldsymbol{u}(f,s) = (10, -8.75)\). Hence for Bob and
\(p < \frac 1 {12}\), it is always better to play \(f\) no matter the
choice of Mafia. For \(p = \frac 1 {12}\), both strategies \(f\) and
\(d\) provide maximal payoff in the worst-case scenario. Lastly, for
\(p > \frac 1 {12}\), it becomes better for Bob to stick to \(d\), as
\(u_1(f,s) < u_1(d,s)\) given the currently considered parameter value.
Combined we get, that Bob's max-min strategy \(s^M_{\text{Bob}}\) is
given by \[
s^M_{\text{Bob}} \in \begin{cases}
    \left\{f\right\}, & p < \frac 1 {12}, \\
    \left\{d,f\right\}, & p = \frac 1 {12}, \\
    \left\{d\right\}, & p > \frac 1 {12}.
\end{cases}.
\]

For the Mafia, their max-min strategies \(s^M_{\text{Mafia}}\) will
analogously satisfy \[
s^M_{\text{Mafia}} \in \mathop{\mathrm{argmax}}_{s' \in \left\{l,s\right\}} \min_{s \in \left\{d,f\right\}} u_2(s, s').
\]

Using similar reasoning as above, for \(p = \frac 1 3\), both strategies
\(l\) and \(s\) provide the same payoff of -5 in the worst-case
scenario, where Bob plays \(f\). On the contrary, for \(p < \frac 1 3\),
the strategy \(l\) proves to be ``better'' (in the current sense of
max-min strategies) as it minimizes the harm Bob can do to the Mafia by
\textbf{f}leeing (i.e.~playing \(f\)). Unsurprisingly, for
\(p > \frac 1 3\), strategy \(s\) turns out to have a better worst-case
scenario payoff. Again, combining these results leads us to max-min
strategy \(s^M_{\text{Mafia}}\) given by \[
s^M_{\text{Mafia}} \in \begin{cases}
    \left\{l\right\}, & p < \frac 1 3, \\
    \left\{l,s\right\}, & p = \frac 1 3, \\
    \left\{s\right\}, & p > \frac 1 3.
\end{cases}
\]

Turning our attention to Nash equilibria, for \(p < \frac 1 {12}\), the
Mafia should not \textbf{s}earch for Bob (it would be wasteful -- worse
in terms of payoff -- for them to search for him and also Bob does not
concern himself too much with the search in this situation), hence Bob
should \textbf{f}lee. This gives us the only Nash equilibrium \((f,l)\)
given the current parameter value.

Considering the parameter
\(p \in \left[\frac 1 {12}, \frac 1 3\right]\), the search now becomes
risky enough for Bob to seriously consider, i.e.~should the Mafia
\textbf{s}earch, Bob will rather \textbf{d}eliver the documents. At the
same time, \textbf{s}earching is still too resource-intensive,
i.e.~provides a worse payoff, in the case that Bob actually
\textbf{f}lees. This implies there are now 2 Nash equilibria \((d,s)\)
and \((f,l)\).

Finally, for \(p > \frac 1 3\), the search is now risky for Bob and
profitable for the Mafia, which forces Bob to \textbf{d}eliver the
documents under the threat of \textbf{s}earch. All in all, this produces
one Nash equilibrium \((d,s)\). All of these Nash equilibria for given
values of parameter \(p\) can be easily checked.

Last, but not least, realize that
\href{https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf\#page=472}{Theorem
45} holds for this game, as it is finite. This implies that for
\(p \in \left[0, \frac 1 {12}\right) \cap \left(\frac 1 3, 1\right]\),
found Nash equilibria are automatically also subgame-perfect.

Consider now \(p \in \left[\frac 1 {12}, \frac 1 3\right)\), then as
\(u_2(f, l) > u_2(f,s)\) holds, it follows that Mafia is non-credibly
threating to \textbf{s}earch in the \((d,s)\) Nash equilibrium, hence it
is \textbf{not} subgame-perfect. The only subgame perfect equilibrium is
\((f,l)\) for this parameter range.

The only remaining situation, \(p = \frac 1 3\), means that for the
Mafia it is equally profitable (giving the same payoff) to either
\textbf{l}eave Bob alone or \textbf{s}earch for him in case he
\textbf{f}lees. Thus \textbf{s}earching is now a credible threat, which
leads to the conclusion that both \((d,s)\) and \((f,l)\) are
subgame-perfect equilibria for \(p = \frac 1 3\).

\end{solution}

\begin{exercise}[]\protect\hypertarget{exr-third}{}\label{exr-third}

Consider the \textbf{one-player} perfect-information extensive-form game
depicted in Figure~\ref{fig-exr3-game}.

\begin{figure}[h]

{\centering \includegraphics{hw2_files/mediabag/problem_3_instr.drawio.pdf}

}

\caption{\label{fig-exr3-game}Exercise 3 game}

\end{figure}

In this game, consider a mixed strategy \(\sigma\) given as follows:
\begin{equation}\protect\hypertarget{eq-pdist}{}{
\begin{aligned}
    &\sigma(ACEHJLM) & &= & & \frac 4 {15} \\
    &\sigma(ACEIKLN) & &= & & \frac 2 5 \\
    &\sigma(BCFHKLM) & &= & & \frac 1 8 \\
    &\sigma(BDFHJLN) & &= & & \frac 1 {24} \\
    &\sigma(BDGHJLN) & &= & & \frac 1 6
\end{aligned}
}\label{eq-pdist}\end{equation}

Find a behavioral strategy \(\beta\) which is equivalent to \(\sigma\).
Is there a unique solution to this task? Justify your answer.

\end{exercise}

\begin{solution}

By looking at Figure~\ref{fig-exr3-game}, we can determine it is a
one-player perfect-information extensive-form game. More so, we have a
mixed strategy \(\sigma\) given by (\ref{eq-pdist}) and our goal is to
find an equivalent behavioral strategy \(\beta\).

First and foremost, we can assign probabilities to actions (or edges):

\begin{itemize}
\tightlist
\item
  action \(A\) shall be played from \(h_0\) (i.e.~playing edge \(A\))
  with probability \(a\) and \(B\) with probability \(1 - a\);
\item
  \(C\) with prob. \(b\) and \(D\) with prob. \(1 - b\);
\item
  \(E\) with prob. \(c_1\), \(F\) with prob. \(c_2\) and lastly \(G\)
  with prob. \(1 - c_1 - c_2\);
\item
  \(H\) with prob. \(d\) and \(I\) with prob. \(1 - d\);
\item
  \(J\) with prob. \(e\) and \(K\) with prob. \(1 - e\);
\item
  \(L\) with probability \(1\), as there is nothing else to choose in
  \(h_5\);
\item
  \(M\) with prob. \(f\) and \(N\) with prob. \(1 - f\).
\end{itemize}

In the lectures, the following statement was presented (modified to be
applicable right away to our problem):

\begin{quote}
Given a behavioral strategy \(\beta\) (which implicitly gives a profile
\((\beta)\) in our one-player extensive-form game), we denote by
\(P_\beta (z)\) the probability of reaching \(z \in Z\) when \(\beta\)
is used, i.e. \begin{equation}\protect\hypertarget{eq-behav-str}{}{
P_\beta (z) = \prod_{l = 1}^k \beta(h_l)(a_l),
}\label{eq-behav-str}\end{equation} where
\(h_0a_1h_1a_2h_2\cdots a_kh_k\) is the unique path from \(h_0\) to
\(h_k = z\).
\end{quote}

Considering our presented notation and the statement from lectures, we
can obtain the following set of equations by enumerating through
(\ref{eq-pdist})

\begin{equation}\protect\hypertarget{eq-mixed-to-behav}{}{
\begin{aligned}
    &P_\beta(z_0) = \beta(h_0)(A) \beta(h_1)(C)\beta(h_3)(H)    & &= abd = \sigma(ACEHJLM)                  = \frac 4 {15} \\
    &P_\beta(z_1) = \beta(h_0)(A) \beta(h_1)(C)\beta(h_3)(I)    & &= ab(1-d) = \sigma(ACEIKLN)              = \frac 2 5 \\
    &P_\beta(z_2) = \beta(h_0)(A) \beta(h_1)(D)\beta(h_3)(J)    & &= a(1-b)e                                = 0 \\
    &P_\beta(z_3) = \beta(h_0)(A) \beta(h_1)(D)\beta(h_3)(K)    & &= a(1-b)(1-e)                            = 0 \\
    &P_\beta(z_4) = \beta(h_0)(B) \beta(h_1)(E)\beta(h_3)(L)    & &= (1-a)c_1\cdot 1                        = 0 \\
    &P_\beta(z_5) = \beta(h_0)(B) \beta(h_1)(F)\beta(h_3)(M)    & &= (1-a)c_2 f = \sigma(BCFHKLM)           = \frac 1 8 \\
    &P_\beta(z_6) = \beta(h_0)(B) \beta(h_1)(F)\beta(h_3)(M)    & &= (1-a)c_2 (1-f) = \sigma(BDFHJLN)       = \frac 1 {24} \\
    &P_\beta(z_7) = \beta(h_0)(B) \beta(h_1)(G)                 & &= (1-a)(1-c_1 - c_2) = \sigma(BDGHJLN)   = \frac 1 6 \\
\end{aligned}
}\label{eq-mixed-to-behav}\end{equation}

First of all, one should notice that from (\ref{eq-mixed-to-behav})
follows that \(a,b,d,c_2,f\) are positive and also that \(a,d,f\) are
strictly less than 1. Using \(P_\beta(z_0)\) and \(P_\beta(z_1)\) from
(\ref{eq-mixed-to-behav}), we can deduce \[
\frac {4} {15d} = ab = \frac 2 {5(1-d)} \implies d = \frac 2 5.
\]

As \(P_\beta(z_4)\) clearly implies \(c_1 = 0\), similar to what we did
before, from \(P_\beta(z_5)\) and \(P_\beta(z_6)\) one can argument \[
\frac 1 {8f} = (1 - a)c_2 = \frac 1 {24(1 - f)} \implies f = \frac 3 4.
\]

Using the computed value for \(f\) and \(c_1\), we can write \[
8 \cdot \left( (1-a)c_2 \frac 3 4 \right) = 6 \cdot \left( (1 - a)(1-c_2) \right) \implies c_2 = \frac 1 2,
\] from which we immediately get \(a = \frac 2 3\) using the last
equation of (\ref{eq-mixed-to-behav}) with now known values of \(c_1\)
and \(c_2\). Finally, this means (given the first equation of
(\ref{eq-mixed-to-behav})) that \(b = 1\), and shifting our focus to
\(P_\beta(z_2)\) and \(P_\beta(z_3)\) shows us that \(e\) can be chosen
arbitrarily such that \(e \in [0,1]\).

Our observations combined amount to the fact that the desired behavioral
strategy \textbf{is not unique} and for a value of parameter
\(e \in [0,1]\) it has the following defining properties

\begin{itemize}
\tightlist
\item
  \(\beta(h_0)(A) = \frac 2 3\;(= a)\) and
  \(\beta(h_0)(B) = \frac 1 3 \;(= 1 - a)\);
\item
  \(\beta(h_1)(C) = 1 \;(= b)\) and \(\beta(h_1)(D) = 0 \;(= 1 - b)\);
\item
  \(\beta(h_2)(E) = 0 \;(= c_1)\),
  \(\beta(h_2)(F) = \frac 1 2 \;(= c_2)\) and
  \(\beta(h_2)(G) = \frac 1 2 \;(= 1 - c_1 - c_2)\);
\item
  \(\beta(h_3)(H) = \frac 2 5 \;(= d)\) and
  \(\beta(h_3)(I) = \frac 3 5 \;(=1 - d)\);
\item
  \(\beta(h_4)(J) = e\) and \(\beta(h_4)(K) = 1 - e\);
\item
  \(\beta(h_5)(L) = 1\);
\item
  \(\beta(h_6)(M) = \frac 3 4 \;(= f)\) and
  \(\beta(h_6)(N) = \frac 1 4 \;(= 1 - f)\).
\end{itemize}

\end{solution}

\begin{exercise}[]\protect\hypertarget{exr-fourth}{}\label{exr-fourth}

Find a two-player perfect-information extensive-form game where all of
the following conditions are satisfied:

\begin{itemize}
\tightlist
\item
  there is a strategy profile whose outcome is for both players better
  than that of any Nash equilibrium;
\item
  there is a Nash equilibrium whose outcome is for both players better
  than that of any subgame-perfect equilibrium;
\item
  there are exactly two subgame-perfect equilibria \(s, s'\), and the
  outcome of \(s\) is for both players better than that of \(s'\).
\end{itemize}

Should you fail to find such a game, try your best (for partial points)
to find a game which matches the requirements as closely as you can.

\end{exercise}

\begin{solution}

Consider a two-player perfect-information extensive-form game \(G\)
given by the following graph, see Figure~\ref{fig-exr4-sol}.

\begin{figure}[h]

{\centering \includegraphics{hw2_files/mediabag/problem_4_sol.drawio.pdf}

}

\caption{\label{fig-exr4-sol}Graph of the game \(G\)}

\end{figure}

Notice that the right subtree (i.e.~subgame rooted in \(h_2\)) is a
modification of the centipede game, which is constructed such that
``being \textbf{d}one with the game'', represented by strategies \(D_i\)
for \(i \in \left\{1, \dots, 3\right\}\), is better for the
corresponding player than the subgame-perfect equilibrium of the subgame
rooted in \(A_i\), which stands for ``playing \textbf{a}long''. In this
subgame, a strategy profile leading to the terminal node \(z_6\)
provides outcome \((7,5)\), which is better than the payoff of any Nash
equilibrium of \(G\).

The middle subgame, rooted in \(h_1\), features 2 subgame perfect
equilibria, which in the full game \(G\) are \[
    \hat s_1 = ((S, W, D_2, N_2), (O, D_1, D_3, C)) \quad \& \quad \hat s_2 = ((S, B, D_2, N_2), (P, D_1, D_3, C)).
\] It is easy to check they are truly subgame-perfect equilibria by
considering all possible one-step deviations.

Finally, the leftmost subgame \(G_L\), rooted in \(h'_1\), contains a
Nash equlibrium \(\hat s^{G_L}_1 = ((NT), (N_1))\) and a subgame-perfect
equilibrium \(\hat s^{G_L}_2 = ((N_2), (C))\). When we consider \(G_L\)
not on its own, but as a subgame of the whole game \(G\), we will see
that \(\hat s^{G_L}_2\) ceases being an equilibrium. Unlike
\(\hat s^{G_L}_2\), \(\hat s^{G_L}_1\) remains a Nash equilibrium in
\(G\) when properly extended to the full game \(G\), e.g. \[
\hat s^N_1 = ((N, W, D_2, NT), (O, D_1, D_3, N_1)).
\]

As \(s^N_1\) retains payoff
\(\boldsymbol{u} \left( s^N_1 \right) = (4,4) > (1,2) = \boldsymbol{u}(\hat s_1)\),
and
\(\boldsymbol{u}\left( s^N_1 \right) = (4,4) > (2,3) = \boldsymbol{u} (\hat s_2)\),
we found the desired Nash equilibrium, which concludes the solution to
this exercise.

\end{solution}

\begin{exercise}[]\protect\hypertarget{exr-fifth}{}\label{exr-fifth}

Prove or disprove: In every \textbf{zero-sum} two-player
perfect-information extensive-form game \(G\), all subgame-perfect
equilibria have the same outcome for player 1.

\end{exercise}

\begin{solution}

Consider a zero-sum two-player perfection-information extensive-form
game \[
G = (N, A, H, Z, \chi, \rho, \pi, h_0, \boldsymbol{u}(z)),
\] such that \(N = \left\{1,2\right\}\) and
\(\boldsymbol{u}(z) = (v(z), -v(z))\). For this game \(G\), the
conditions of the
\href{https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf\#page=472}{Theorem
45}, which states

\begin{quote}
For every finite perfect-information extensive-form game and for each
node \(h \in H\) the attached \(s^h\) is a \textbf{subgame-perfect
equilibrium} (SPE) and the attached vector satisfies \[
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = (u_1(s^h), \dots, u_n(s^n))
\]
\end{quote}

are met if \(G\) is \textbf{finite}.

Consider two (possibly different) SPEs \(s, s^*\). Should they result in
the same terminal node \(z\) (or two terminal nodes giving the same
value \(\boldsymbol{u}(z)\)), the statement is trivially true. Therefore
suppose that when both players play the strategy profile \(s\), or
\(s^*\), the game results in \(z\), or respectively \(z^*\), such that
\(z \neq z^*\) and
\(\boldsymbol{u}(z) = \boldsymbol{u}(s) \neq \boldsymbol{u}(s^*) = \boldsymbol{u}(z^*)\)
(otherwise the statement is again trivially satisfied). Surely, both
\(z\) and \(z^*\) are descendants of \(h_0\). Thus there exists a node
\(h \in H\), such that \(h\) is an ancestor of both \(z\) and \(z^*\),
but the successor \(h_s = \pi(h, s(h))\), and
\(h_{s^*} = \pi(h, s^*(h))\), is not an ancestor of \(z^*\),
respectively \(h_{s^*}\) is not an ancestor of \(z\).

Using the
\href{https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf\#page=472}{Theorem
45} and the fact that \(s\) is a SPE in \(G\) (but also in \(G^h\) and
\(G^{h_s}\)), \(s\) must provide a best-response action
\(a \in \chi(h)\) to any belief \(b\) in the subgame \(G^h\). As
discussed before, here \(a = h_s\) and we obtain
\begin{equation}\protect\hypertarget{eq-s-spe}{}{
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = \boldsymbol{u}(s^{h_s}) = \boldsymbol{u}(z).
}\label{eq-s-spe}\end{equation}

Similarly, \(s^*\) is also an SPE in \(G\), hence
\begin{equation}\protect\hypertarget{eq-sstar-spe}{}{
\boldsymbol{u}(h) = \boldsymbol{u}(s^h) = \boldsymbol{u}(s^{h_{s^*}}) = \boldsymbol{u}(z^*).
}\label{eq-sstar-spe}\end{equation}

Recall that \(G\) is a \textbf{zero-sum} game, thus WLOG (otherwise we
could simply swap their ``names'') this leads to
\begin{equation}\protect\hypertarget{eq-spes}{}{
u_1(z) > u_1(z^*) \quad \& \quad u_2(z) < u_2(z^*)
}\label{eq-spes}\end{equation} for \(z, z^*\) as we have assumed them
(providing different payoffs). Now presume, that player 1 chooses an
action in node \(h\), i.e.~\(\rho(h) = 1\). Then from (\ref{eq-s-spe})
we get \(u_1(h) = u_1(z)\), but from (\ref{eq-sstar-spe}) also \[
u_1(z) = u_1(h) = u_1(h) = u_1(z^*),
\] which contradicts (\ref{eq-spes}). Analogously, for the case
\(\rho(h) = 2\), we get a similar contradiction.

It shall also be noted that
\href{https://is.muni.cz/auth/el/fi/podzim2023/IA168/um/OLD_games_slides.pdf\#page=472}{Theorem
45} only applies to \textbf{finite} games -- infinite games may not have
any subgame-perfect equilibrium. But if there exists a SPE in an
infinite game \(G\), then there exists a SPE for all subgames. Hence our
reasoning is still valid because for every non-terminal node, we can
compare its corresponding subgame-perfect equilibria (more precisely
their payoffs).

Altogether, we have shown that there cannot be two SPEs \(s,s^*\) in a
zero-sum two-player perfect-information extensive-form game \(G\), such
that \(\boldsymbol{u}(s) \neq \boldsymbol{u}(s^*)\).

\end{solution}



\end{document}
